#ifndef _CLI_ALGORITHMS_INTROSPECTION_COMMAND_H_
#define _CLI_ALGORITHMS_INTROSPECTION_COMMAND_H_

#include <command/Command.h>
#include <environment/Environment.h>

namespace cli {

class AlgorithmsIntrospectionCommand : public Command {
	std::string m_param;

public:
	AlgorithmsIntrospectionCommand ( std::string param ) : m_param ( std::move ( param ) ) {
	}

	virtual Command::Result run ( Environment & ) const override {
		if ( m_param == "" ) {
			abstraction::Registry::listAlgorithms ( );
		} else if ( m_param.find ( "::", m_param.size ( ) - 2 ) != std::string::npos ) {
			abstraction::Registry::listAlgorithmGroup ( m_param );
		} else {
			abstraction::Registry::listAlgorithmOverloads ( m_param );
		}
		return Command::Result::OK;
	}
};

} /* namespace cli */

#endif /* _CLI_ALGORITHMS_INTROSPECTION_COMMAND_H_ */
