#ifndef _CLI_DATA_TYPE_INTROSPECTION_COMMAND_H_
#define _CLI_DATA_TYPE_INTROSPECTION_COMMAND_H_

#include <command/Command.h>
#include <environment/Environment.h>

namespace cli {

class DataTypesIntrospectionCommand : public Command {
	std::string m_param;

public:
	DataTypesIntrospectionCommand ( std::string param ) : m_param ( std::move ( param ) ) {
	}

	virtual Command::Result run ( Environment & ) const override {
		if ( m_param == "" ) {
			abstraction::Registry::listDataTypes ( );
		} else if ( m_param.find ( "::", m_param.size ( ) - 2 ) != std::string::npos ) {
			abstraction::Registry::listDataTypeGroup ( m_param );
		} else {
			throw exception::CommonException ( "Invalid DataType introspection param" );
		}
		return Command::Result::OK;
	}
};

} /* namespace cli */

#endif /* _CLI_DATA_TYPE_INTROSPECTION_COMMAND_H_ */
