/*
 * Registry.h
 *
 *  Created on: 10. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _REGISTRY_H_
#define _REGISTRY_H_

#include <abstraction/OperationAbstraction.hpp>

namespace abstraction {

class Registry {
public:
	static void listAlgorithmGroup ( const std::string & group );
	static void listAlgorithmOverloads ( const std::string & algorithm );
	static void listAlgorithms ( );

	static void listDataTypes ( );
	static void listDataTypeGroup ( const std::string & group );

	static void listCastsFrom ( const std::string & type );
	static void listCastsTo ( const std::string & type );

	static std::shared_ptr < abstraction::OperationAbstraction > getAlgorithmAbstraction ( const std::string & name, const ext::vector < std::string > & paramTypes );
	static std::shared_ptr < abstraction::OperationAbstraction > getAlgorithmAbstraction ( const std::string & name, const ext::vector < std::string > & paramTypes, bool & unwrap, bool & normalize );
	static std::shared_ptr < abstraction::OperationAbstraction > getCastAbstraction ( const std::string & target, const std::string & param, bool & normalize );
	static bool isCastNoOp ( const std::string & target, const std::string & param );
	static std::shared_ptr < abstraction::OperationAbstraction > getImmediateAbstraction ( const std::string & result, std::string value );
	static std::shared_ptr < abstraction::OperationAbstraction > getNormalizeAbstraction ( const std::string & param );
	static std::shared_ptr < abstraction::OperationAbstraction > getDowncastAbstraction ( const std::string & concrete, const std::string & base );
	static std::shared_ptr < abstraction::OperationAbstraction > getValuePrinterAbstraction ( const std::string & param );
	static std::shared_ptr < abstraction::OperationAbstraction > getXmlFileWriterAbstraction ( const std::string & param, std::string filename );
	static std::shared_ptr < abstraction::OperationAbstraction > getXmlParserAbstraction ( const std::string & typeName, ext::deque < sax::Token > tokens );
};

} /* namespace abstraction */

#endif /* _REGISTRY_H_ */

