/*
 * VoidOperationAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _VOID_OPERATION_ABSTRACTION_HPP_
#define _VOID_OPERATION_ABSTRACTION_HPP_

#include <abstraction/OperationAbstraction.hpp>
#include <tuple>

namespace abstraction {

class VoidOperationAbstraction : public OperationAbstraction {
public:
	template < typename Callable, typename ... Ts, size_t ... Indexes >
	inline void run_helper ( Callable callback, const ext::tuple < Ts ... > & inputs, std::index_sequence < Indexes ... > ) const {
		callback ( std::get < Indexes > ( inputs )->getData ( ) ... );
	}

	template < typename Callable, typename T >
	inline void run_helper ( Callable callback, const T & input ) const {
		callback ( input->getData ( ) );
	}

	virtual ext::type_index getReturnTypeIndex ( ) const override {
		return ext::type_index ( typeid ( void ) );
	}

	virtual ext::type_index getRuntimeReturnTypeIndex ( ) const override {
		return ext::type_index ( typeid ( void ) );
	}

	virtual bool cached ( ) const override {
		return false;
	}
};

} /* namespace abstraction */

#endif /* _VOID_OPERATION_ABSTRACTION_HPP_ */
